// initial_derivation.hh: this file is part of the Vaucanson project.
//
// Vaucanson, a generic library for finite state machines.
//
// Copyright (C) 2005, 2006 The Vaucanson Group.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// The complete GNU General Public Licence Notice can be found as the
// `COPYING' file in the root directory.
//
// The Vaucanson Group consists of people listed in the `AUTHORS' file.
//
#ifndef VCSN_ALGORITHMS_INITIAL_DERIVATION_HH
# define VCSN_ALGORITHMS_INITIAL_DERIVATION_HH

/** @addtogroup algorithms *//** @{ */
/**
 * @file initial_derivation.hh
 *
 * Declaration of the initial derivation visitor, used for
 * smart_derivative_automaton.
 *
 */
/** @} */

# include <vaucanson/design_pattern/design_pattern.hh>

# if !defined VCSN_USE_INTERFACE_ONLY && !defined VCSN_USE_LIB
#  include <vaucanson/algorithms/initial_derivation.hxx>
# endif // VCSN_USE_INTERFACE_ONLY

#endif // ! VCSN_ALGORITHMS_INITIAL_DERIVATION_HH
