// automata.hxx: this file is part of the Vaucanson project.
//
// Vaucanson, a generic library for finite state machines.
//
// Copyright (C) 2001, 2002, 2003, 2004, 2005 The Vaucanson Group.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// The complete GNU General Public Licence Notice can be found as the
// `COPYING' file in the root directory.
//
// The Vaucanson Group consists of people listed in the `AUTHORS' file.
//
#ifndef VCSN_AUTOMATA_CONCEPT_AUTOMATA_HXX
# define VCSN_AUTOMATA_CONCEPT_AUTOMATA_HXX

#include <vaucanson/automata/concept/automata_base.hh>
#include <vaucanson/misc/unique.hh>

namespace vcsn {

  template <class Series>
  Automata<Series>::Automata(const series_set_t& s):
    SetSlot<Series>(s)
  {}

  template <class Series>
  const Series&
  Automata<Series>::series() const
  {
    return this->_structure_get();
  }

  template <class Series>
  bool
  operator==(const Automata<Series>& lhs,
	     const Automata<Series>& rhs)
  {
    return & lhs.series() == & rhs.series();
  }

} // vcsn

#endif // ! VCSN_AUTOMATA_CONCEPT_AUTOMATA_HXX
