// design_pattern.hh: this file is part of the Vaucanson project.
//
// Vaucanson, a generic library for finite state machines.
//
// Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006 The Vaucanson Group.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// The complete GNU General Public Licence Notice can be found as the
// `COPYING' file in the root directory.
//
// The Vaucanson Group consists of people listed in the `AUTHORS' file.
//
#ifndef VCSN_DESIGN_PATTERN_DESIGN_PATTERN_HH
# define VCSN_DESIGN_PATTERN_DESIGN_PATTERN_HH

/** @addtogroup design_pattern Fundamental C++: the Element design pattern.
 *
 * Core constructs for Vaucanson.
 *
 * This module contains definitions for the design pattern used in
 * Vaucanson, so called "Element". This design pattern is more deeply
 * described in the paper by Yann Rgis-Gianas and Raphal Poss:
 * <em>On orthogonal specialization in C++: Dealing with efficiency
 * and algebraic abstraction in Vaucanson</em>. In the proceedings of
 * the Parallel/High-performance Object-Oriented Scientific Computing
 * (POOSC'2003) Darmstadt, Germany July 2003.
 *
 * @see http://publications.lrde.epita.fr/200307-Poosc
*/

# include <vaucanson/design_pattern/element.hh>

#endif // ! VCSN_DESIGN_PATTERN_DESIGN_PATTERN_HH
