// misc.hh: this file is part of the Vaucanson project.
//
// Vaucanson, a generic library for finite state machines.
//
// Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006 The Vaucanson Group.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// The complete GNU General Public Licence Notice can be found as the
// `COPYING' file in the root directory.
//
// The Vaucanson Group consists of people listed in the `AUTHORS' file.
//
#ifndef VCSN_MISC_MISC_HH
# define VCSN_MISC_MISC_HH

/** @addtogroup misc Miscellaneous constructs used by Vaucanson *//** @{ */

namespace vcsn {

  /**
   * The namespace for miscellaneous constructs.
   *
   * This namespace holds C++ constructs and tools used in Vaucanson.
   * Those files are miscellany because they are not related to
   * core mathematical part of the library.  If you are looking for
   * tools to be used by the user, like dumpers, see namespace `tools'.
   *
   */
  namespace misc {}
}

/** @} */

#endif // ! VCSN_MISC_MISC_HH
